From f88c283e0ba68689992dbce232abe1883ecebe68 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 22 2016 06:22:07 +0000
Subject: [PATCH 413/1001] Implement the endpoint used to update the ordering of the widget in a hub


---

diff --git a/hubs/app.py b/hubs/app.py
index 2cbaffe..abd610b 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -125,14 +125,57 @@ def hub_edit_get(name):
         'hubs.html', hub=hub, session=session, edit=True)
 
 
-@app.route('/<name>/edit/', methods=['POST'])
-@app.route('/<name>/edit', methods=['POST'])
+@app.route('/<name>/save/', methods=['POST'])
+@app.route('/<name>/save', methods=['POST'])
 def hub_edit_post(name):
-    #hub = get_hub(session, name)
-    # TODO -- save things to the db ... and then redirect
-    hub.last_edited = datetime.datetime.utcnow()
-    raise NotImplementedError('TODO - save changes to hub config')
-    flask.redirect(flask.url_for('hub', name=name))
+    hub = get_hub(session, name)
+
+    error = False
+    # Check the input submitted
+    widget_ids = [
+        w.strip().replace('widget-', '') for w in flask.request.form.getlist('widgets[]')
+        if w.strip()
+    ]
+    try:
+        widget_ids = [int(w) for w in widget_ids]
+    except:
+        flask.flash('Invalid widget identifiers submitted', 'error')
+        error = True
+
+    indexes = [
+        i.strip() for i in flask.request.form.getlist('indexes[]')
+        if i.strip()
+    ]
+
+    try:
+        indexes = [int(i) for i in indexes]
+    except:
+        flask.flash('Invalid indexes submitted', 'error')
+        error = True
+
+    if len(widget_ids) != len(indexes):
+        flask.flash(
+            'The number of indexes and the number of widgets are not of '
+            'the same length', 'error')
+        error = True
+
+    # If all good, update the database
+    if not error:
+        for cnt, wid in enumerate(widget_ids):
+            widget = hubs.models.Widget.get(session, wid)
+            if widget.index != indexes[cnt]:
+                widget.index = indexes[cnt]
+                session.add(widget)
+        hub.last_edited = datetime.datetime.utcnow()
+        session.add(hub)
+        try:
+            session.commit()
+        except Exception as err:
+            flask.flash(
+                'Could not save your changes to the database '\
+                'if the error persists, please warn an admin',
+                'error')
+    return flask.redirect(flask.url_for('hub', name=name))
 
 
 @app.route('/<hub>/<idx>/')

